/*_________________________________________________________________________________________________________________________________________________________

SNS_Breakout_Boxes.mq4 
Copyright 2009 Steven N. Scott
mailto:steven.n.scott@gmail.com                              
_________________________________________________________________________________________________________________________________________________________
 
		[ I STAND ON THE SHOULDERS OF GIANTS ]

		This MQ4 indicator was made possible from a combination of inidcator code shared by other programmers on various forex forums around the web.  
		I DO NOT claim that this code is therefore 100% uniquely mine. I borrowed or reused several great ideas and mean NO disrespect to the original
		authors if they happen to notice sections in here that look	suspiciously like theirs.
		
		This is one of the first "signficant" indicators I created for MT4. It started out as just a simple daily box indicator, over time I have expanded 
		it to display both a WEEKLY box along with daily boxes and is now very user customizable through exposed properties.
		
_________________________________________________________________________________________________________________________________________________________
VERSION HISTORY
v1.0 		- 	initial release																				10/30/2009
v1.1		-  added user adjustability to Gauge														11/09/2009
v1.2		-  modified to use SNS_ObjectLibrary.mqh and adjusted DEFAULT end times			11/30/2009
_________________________________________________________________________________________________________________________________________________________


NOTE:  SNS_ObjectLIbrary.ex4 needs to be in your MetaTrader[EXPERTS\LIBRARIES] folder and SNS_ObjectLibrary.mqh needs to be in [EXPERTS\INCLUDES]


*/ 



// THE FOLLWING INCLUDE (MQH) FILE NEEDS TO BE IN THE EXPERTS\INCLUDES FOLDER
#include <SNS_ObjectLibrary.mqh>

#define note_btp1 "System 'rules' say don't cash out yet"
#define note_btp2 "System 'rules' say maybe cash out partial"
#define note_btp3 "System 'rules' say start thinking about cashing out"
#define note_stp1 "System 'rules' say don't cash out yet"
#define note_stp2 "System 'rules' say maybe cash out partial"
#define note_stp3 "System 'rules' say start thinking about cashing out"

#property copyright "Copyright 2009 Steven N. Scott"
#property link      "steven.n.scott@gmail.com"
#property indicator_chart_window

//____________________________________________________________________________________________________________________________________________________________
// INDICATOR CUSTOMIZABLE PROPERTIES

extern string 		Week.box.params   		= "Week Box Parameters--------------";   
extern string     Week.note					= "Days week starts & ends: 0=Sunday 1=Monday";
extern int			Week.StartDay 				= 0;
extern int			Week.EndDay 				= 1;
extern string     Week.Begin					= "23:00";  
extern string     Week.End						= "10:00";
extern bool			Week.SolidBox				= true;
extern int			Week.LineWidth				= 5;
extern int			Week.LineStyle				= 0;

extern string 		Day.box.params  			= "Daily Box Parameters-------------"; 
extern string     Day.Begin					= "23:00";  
extern string     Day.End						= "10:00";
extern bool			Day.SolidBox				= true;
extern int			Day.LineWidth				= 5;
extern int			Day.LineStyle				= 0;

extern string 		Box.params	      		= ""; 
extern string 		Box.common  				= "Common Parameters----------------"; 
extern int 			Box.EntryBuffer   		= 20;
extern double		Box.Minimum					= 30.0;
extern bool   		Box.ShowPrice 				= True; 
extern color		Box.PriceColor				= White;
extern int			Box.PriceWidth				= 2;
extern int			Box.PriceStyle				= 0;
extern string		Box.Font						= "Verdana Bold";    
extern color  		Box.FontColor    			= Gold; 
extern int			Box.FontSize				= 12;
extern string		note.offsets				= "Distance above/below line to show price";
extern int    		Box.FontHighOffSet    	= 6;  
extern int    		Box.FontLowOffSet    	= 1;  

extern string 		spacer3.xxxxxxxxx	      		= ""; 
extern string 		note.targets				= "Target Profit Multipliers---------"; 
extern double 		Target.1    				= 1;
extern double 		Target.2    				= 2;
extern double 		Target.3    				= 3;
extern string		Target.Name1				= "1x";
extern string		Target.Name2				= "2x";
extern string		Target.Name3				= "3x";
extern string 		Target.Font     			= "Verdana Bold";
extern color  		Target.FontColor  		= White ;
extern int    		Target.FontSize			= 10;
extern int        Target.Width  				= 5;
extern int        Target.Style   			= STYLE_SOLID;
extern int        Entry.Width   				= 5;
extern int        Entry.Style   				= STYLE_SOLID;

extern string 		spacer4.xxxxxxxxx	      		= ""; 
extern string 		note.box  	   			= "Box Appearance Parameters--------";   
extern string 		note.gbxspc      			= "** WEEKLY BOX"; 
extern color  		WeekStartBox.Color		= Blue; 
extern color      AllWeekBox.Color  		= MidnightBlue; 
extern color      WeekRange.Color   		= MediumBlue;   
extern color      WeekEntry.Color   		= Aqua;
extern color		WeekTarget.Color			= RoyalBlue;

extern string 		note.dbxspc	      		= "** DAILY BOX"; 
extern color  		DayStartBox.Color			= DarkOrchid;   
extern color		AllDayBox.Color			= Indigo;
extern color      DayRange.Color    		= Purple;
extern color      DayEntry.Color    		= Orchid;
extern color		DayTarget.Color			= MediumOrchid;

extern string 		spacer5.xxxxxxxxx	      		= ""; 
extern string		note.gauge					= "Gauge Parameters======================";
extern bool			Gauge.Show					= true;
extern string 		spacer6.xxxxxxxxx	      	= ""; 
extern string		note.wgauge					= "WEEKLY Gauge Appearance Parameters----";
extern int			Gauge.Week.Corner			= 1;
extern int        Gauge.Week.X	  			= 300;
extern int        Gauge.Week.Y	 			= 20;
extern string		Gauge.WeekHdr.Font		="Verdana Bold";
extern int			Gauge.WeekHdr.FontSize	= 18;
extern string		Gauge.WeekRng.Font		="Verdana";
extern int			Gauge.WeekRng.FontSize	= 10;
extern int			Gauge.WeekRng.XOffset	= 110;
extern int			Gauge.WeekRng.YOffset	= 3;
extern string		Gauge.WeekPip.Font		="Verdana";
extern int			Gauge.WeekPip.FontSize	= 12;
extern int			Gauge.WeekPip.XOffset	= 225;
extern int			Gauge.WeekPip.YOffset	= 3;
extern string		Gauge.WeekMsg.Font		="Verdana Bold";
extern int			Gauge.WeekMsg.FontSize	= 14;
extern int			Gauge.WeekMsg.XOffset	= 0;
extern int			Gauge.WeekMsg.YOffset	= 25;

extern string 		spacer7.xxxxxxxxx	      		= ""; 
extern string		note.dgauge					= "DAILY Gauge Appearance Parameters----";
extern int			Gauge.Day.Corner			= 1;
extern int        Gauge.Day.X   				= 300;
extern int        Gauge.Day.Y   				= 70;
extern string		Gauge.DayHdr.Font			="Verdana Bold";
extern int			Gauge.DayHdr.FontSize	= 18;
extern string		Gauge.DayRng.Font			="Verdana";
extern int			Gauge.DayRng.FontSize	= 10;
extern int			Gauge.DayRng.XOffset		= 110;
extern int			Gauge.DayRng.YOffset		= 3;
extern string		Gauge.DayPip.Font			="Verdana";
extern int			Gauge.DayPip.FontSize	= 12;
extern int			Gauge.DayPip.XOffset		= 225;
extern int			Gauge.DayPip.YOffset		= 3;
extern string		Gauge.DayMsg.Font			="Verdana Bold";
extern int			Gauge.DayMsg.FontSize	= 14;
extern int			Gauge.DayMsg.XOffset		= 0;
extern int			Gauge.DayMsg.YOffset		= 25;

extern string 		spacer8.xxxxxxxxx	      		= ""; 
extern string		note.shading				= "Profit Zone Shading Options------";
extern bool       Shade.DailyZones  		= false;
extern bool       Shade.WeeklyZones 		= false;  
extern color		Shade.Long.TP1				= C'0,40,0';  
extern color		Shade.Long.TP2				= C'0,60,0';  
extern color		Shade.Long.TP3				= C'0,80,0';  
extern color		Shade.Long.TP4				= C'0,100,0';
extern color		Shade.Short.TP1			= C'40,0,0';  
extern color		Shade.Short.TP2			= C'60,0,0';
extern color		Shade.Short.TP3			= C'80,0,0';
extern color		Shade.Short.TP4			= C'100,0,0';

extern string 		spacer9.xxxxxxxxx	      		= ""; 
extern string		misc.note					= "Other options--------------------";
extern bool			Hints.Show					= false;
extern string		Hints.Font					= "Verdana";
extern int			Hints.FontSize				= 10;
extern color		Hints.FontColor			= Orange;


//____________________________________________________________________________________________________________________________________________________________
//INTERNAL GLOBALS

string   nametag="SNSBX_",type,boxdaybegin, boxdayend, dhc, dhf,symbol, tChartPeriod;
double   top, bottom, point, open, BoxSize;
datetime left, right, daybegin, dayend, t3, t4, t99, TextTime ;
int    	digits, period,b1,b2,b3,FirstCandleEnd; 
color		bp1c,bp2c,bp3c,bp4c,sp1c,sp2c,sp3c,sp4c;


//***************************************************************************************************************************************************************
//STANDARD INDICATOR FUNCTIONS

int init() {
   
   IndicatorShortName("Daily Box");

   period       =  Period() ;    
   symbol       =  Symbol() ;
   digits       =  Digits ;   
   point        =  Point ;

   if(digits == 5 || digits == 3) { digits = digits - 1 ; point = point * 10 ; }  
   
   return(0);
   
}


 
void deinit(){
    
  DeleteObjectsByPrefix(nametag);
  
  Comment("");
}

  
int start(){

	deinit();
	
   Box("WBOX_","WEEK",3, true, Shade.WeeklyZones);
   
   Box("DBOX_" ,"DAY",3, false, Shade.DailyZones);
 
   WindowRedraw();
   
}


//**************************************************************************************************************************************************
//CUSTOM INDICATOR FUNCTIONS


int Box(string tag, string BoxType, int pricecolumn, bool Weekly, bool shadeBuyZones) {

   string boxtime;
   int linewidth,linestyle,ws,ds;
   
   double bep, btp1, btp2, btp3, btp4, bsl;
   double sep, stp1, stp2, stp3, stp4, ssl;
   double drange,lto,uto;
   bool solid;

   datetime eod;
   
  	color BoxColor,RangeColor,EntryColor, TargetColor;

	ws=FindStartBar(Week.StartDay, Week.Begin); 
	ds=FindStartBar(-1,Day.Begin);
	
	if (!Weekly && ws==ds) return(0);

   TextTime = Time[pricecolumn]; 
   type=BoxType;


   if (Weekly) {
   
   	b1=ws; 
		b2=FindEndBar(b1,Week.EndDay,Week.End);   	
		
   } else {
   
   	b1=ds;
   	b2=FindEndBar(b1,-1,Day.End);
   	
   }
   b3=(b1-b2)+1; 
  
   top      =  High[iHighest(NULL,0, MODE_HIGH, b3, b2)];
   bottom   =  Low[iLowest(NULL, 0, MODE_LOW , b3, b2)];
   BoxSize	=  (top-bottom)/point;

   left     =  iTime(NULL,0,b1);
   right    =  iTime(NULL,0,b2);
   open     =  Open[b1];  

  	if(Weekly){
  
      	BoxColor=WeekStartBox.Color;
      	RangeColor=WeekRange.Color;
      	EntryColor=WeekEntry.Color;
      	TargetColor=WeekTarget.Color;
      	linewidth=Week.LineWidth;
      	linestyle=Week.LineStyle;
      	boxtime = Week.Begin + " - " + Week.End;
      	solid=Week.SolidBox;
      
  	} else {

      	BoxColor=DayStartBox.Color;
      	RangeColor=DayRange.Color;
      	EntryColor=DayEntry.Color;
      	TargetColor=DayTarget.Color;
      	linewidth=Day.LineWidth;
      	linestyle=Day.LineStyle;
      	boxtime = Day.Begin + " - " + Day.End;
      	solid=Day.SolidBox;
       
  	}
  
  	tag=nametag + tag; 
  	Draw_Box(tag,"Box",BoxColor,left,top,right,bottom,solid,linewidth,linestyle,0);
	eod=iTime(NULL,0,0);
  			
  	if(Weekly) Draw_Box(tag,"WBox",AllWeekBox.Color, right,top,eod, bottom, solid,linewidth,linestyle,0);
  	    else   Draw_Box(tag,"DBox",AllDayBox.Color, right,top,eod, bottom, solid,linewidth,linestyle,0);
  	
   if(Box.ShowPrice){
 
   	Draw_TLine(tag,BoxType+"_open",Box.PriceStyle,Box.PriceWidth,Box.PriceColor,left,open,right,open,true,false,0); 
   	Draw_Text(tag,BoxType+"_OpenT",		BoxType+" OPEN: "+DoubleToStr(open, Digits),		right, open-Box.FontLowOffSet*point, 		Box.Font, Box.FontSize, Box.FontColor,true,0); 
   	Draw_Text(tag,BoxType+"_BoxHigh",	BoxType+" HIGH: "+DoubleToStr(top, Digits),		right, top+Box.FontHighOffSet*point, 		Box.Font, Box.FontSize, Box.FontColor,true,0); 
   	Draw_Text(tag,BoxType+"_BoxLow",		BoxType+" LOW: "+DoubleToStr(bottom, Digits),	right, bottom-Box.FontLowOffSet*point, 	Box.Font, Box.FontSize, Box.FontColor,true,0); 

   }

	drange=(top-bottom);
	bep  = top + (Box.EntryBuffer * point);
   btp1 = bep + (drange * Target.1);
   btp2 = bep + (drange * Target.2); 
   btp3 = bep + (drange * Target.3);
   btp4 = btp3+ 25*point;
   bsl  = bottom;
   
   sep  = bottom - (Box.EntryBuffer * point);
   stp1 = sep -  (drange * Target.1);
   stp2 = sep -  (drange * Target.2); 
   stp3 = sep -  (drange * Target.3);
   stp4 = stp3- 25*point;
   ssl  = top;

   drange = (top-bottom)/point;
   uto = 10*point;
   lto =  point;

  	// Trigger Lines

  	Draw_Text(tag,"BATL"," " + type + " Buy @ "+DoubleToStr(bep,Digits)+"", TextTime,bep-lto,Target.Font,Target.FontSize,Target.FontColor,false,0);
  	Draw_Box(tag,"ENTRY" , EntryColor,left, bep, eod, sep, false, Entry.Width, Entry.Style,0); 
  
  	Draw_Text(tag,"BTP1L"," " + type +" " +Target.Name1+": "+DoubleToStr(btp1,Digits)+"", TextTime,btp1-lto,Target.Font,Target.FontSize,Target.FontColor,false,0);
  	Draw_TLine(tag,"BTP1", Target.Style,Target.Width,TargetColor,left,btp1,eod,btp1,false,true,0); 

  	Draw_Text(tag,"BTP2L"," " + type +" " +Target.Name2+": "+DoubleToStr(btp2,Digits)+"", TextTime,btp2-lto,Target.Font,Target.FontSize,Target.FontColor,false,0);
  	Draw_TLine(tag,"BTP2", Target.Style,Target.Width,TargetColor,left, btp2,eod, btp2, false, true,0); 

  	Draw_Text(tag,"BTP3L"," " +type+" " +Target.Name3+": "+DoubleToStr(btp3,Digits)+"", TextTime,btp3-lto,Target.Font,Target.FontSize,Target.FontColor,false,0);
  	Draw_TLine(tag,"BTP3",Target.Style,Target.Width,TargetColor,left,btp3,eod, btp3, false, true,0); 

  	Draw_Text(tag,"SATL"," " + type + " Sell @ "+DoubleToStr(sep,Digits)+"", TextTime,sep-lto,Target.Font,Target.FontSize,Target.FontColor,false,0);

  	Draw_Text(tag,"STP1L"," " + type +" " +Target.Name1+": "+DoubleToStr(stp1,Digits)+"", TextTime,stp1-lto,Target.Font,Target.FontSize,Target.FontColor,false,0);
  	Draw_TLine(tag,"STP1",Target.Style,Target.Width,TargetColor,left,stp1,eod, stp1, false, true,0); 

  	Draw_Text(tag,"STP2L"," " + type +" " +Target.Name2+": "+DoubleToStr(stp2,Digits)+"", TextTime,stp2-lto,Target.Font,Target.FontSize,Target.FontColor,false,0);
  	Draw_TLine(tag,"STP2",Target.Style,Target.Width,TargetColor,left,stp2,eod, stp2, false, true,0); 

  	Draw_Text(tag,"STP3L"," " + type +" " +Target.Name3+": "+DoubleToStr(stp3,Digits)+"", TextTime,stp3-lto,Target.Font,Target.FontSize,Target.FontColor,false,0);
  	Draw_TLine(tag,"STP3",Target.Style,Entry.Width,TargetColor,left,stp3, eod, stp3, false, true,0);  
  	
  	if (Hints.Show) {
  
  		Draw_Text(tag,BoxType+"_Hint_BTP1",note_btp1, left,btp1-lto,Hints.Font,Hints.FontSize,Hints.FontColor,false,0);
  		Draw_Text(tag,BoxType+"_Hint_BTP2",note_btp2, left,btp2-lto,Hints.Font,Hints.FontSize,Hints.FontColor,false,0);
  		Draw_Text(tag,BoxType+"_Hint_BTP3",note_btp3, left,btp3-lto,Hints.Font,Hints.FontSize,Hints.FontColor,false,0);
  		Draw_Text(tag,BoxType+"_Hint_STP1",note_stp1, left,stp1-lto,Hints.Font,Hints.FontSize,Hints.FontColor,false,0);
  		Draw_Text(tag,BoxType+"_Hint_STP2",note_stp2, left,stp2-lto,Hints.Font,Hints.FontSize,Hints.FontColor,false,0);
  		Draw_Text(tag,BoxType+"_Hint_STP3",note_stp3, left,stp3-lto,Hints.Font,Hints.FontSize,Hints.FontColor,false,0);
  	
  	}
  
	// color shades the "target" zones (obscures chart too much for me, but some people might like it)
   if(shadeBuyZones) {
   	
		bp1c = Shade.Long.TP1;
		bp2c = Shade.Long.TP2;
		bp3c = Shade.Long.TP3;
		bp4c = Shade.Long.TP4;

		sp1c = Shade.Short.TP1;
		sp2c = Shade.Short.TP2;
		sp3c = Shade.Short.TP3;
		sp4c = Shade.Short.TP4;   	
    
   	Draw_Box(tag, "BuyZone", 			bp1c, left, btp1, Time[0], bep, 	true,0,0,0);
   	Draw_Box(tag, "Buy.Target.1", 	bp2c, left, btp2, Time[0], btp1, true,0,0,0);
   	Draw_Box(tag, "Buy.Target.2", 	bp3c,	left, btp3, Time[0], btp2, true,0,0,0);
   	Draw_Box(tag, "Buy.Target.3", 	bp4c,	left, btp4, Time[0], btp3, true,0,0,0);

   	Draw_Box(tag, "SellZone", 			sp1c, left, stp1, Time[0], sep, 	true,0,0,0);
   	Draw_Box(tag, "Sell.Target.1", 	sp2c, left, stp2, Time[0], stp1, true,0,0,0);
   	Draw_Box(tag, "Sell.Target.2", 	sp3c,	left, stp3, Time[0], stp2, true,0,0,0);
   	Draw_Box(tag, "Sell.Target.3", 	sp4c,	left, stp4, Time[0], stp3, true,0,0,0);

   }   
   
   string 	tAlert			= "WAIT";
   string 	boxsig			= BoxType+ "_Signal";
   string 	boxname			= BoxType+ "_Name";
   color 	tAlertColor		= DarkGray;
   double 	price				= 0;
   
   int win=0,signal.x.offset,signal.y.offset;
   
   ObjectDelete(boxsig);
   
   if(Weekly){ signal.x.offset=Gauge.Week.X; signal.y.offset=Gauge.Week.Y; } 
        else { signal.x.offset=Gauge.Day.X;  signal.y.offset=Gauge.Day.Y; }
   
   if (Ask>=top) {
   
      if (Ask>=bep) { tAlert="LONG @ "; tAlertColor=Lime;} else {tAlert="PREPARE BUY @ "; tAlertColor=Yellow; }
      price=bep;
   
   } else if (Bid<=bottom) {
   
      if (Bid<=sep) { tAlert="SHORT @ "; tAlertColor=Red;} else {tAlert="PREPARE SELL @ "; tAlertColor=Yellow; }
      price=sep;
   
   }
   
   if (price>0) tAlert=tAlert+DoubleToStr(price,Digits);
   
   // Weekly/Daily guage header
   
   if (Gauge.Show) {
   	
   	string gh.font, gp.font, gr.font, gm.font;
   	int g.corner, gh.size, gp.size, gr.size,  gm.size, r.x,r.y,p.x,p.y,m.x,m.y,xadj,yadj;
   	color gp.color;
   	
      
   	if (Weekly) {
   	
   		g.corner= Gauge.Week.Corner;
   		gh.font = Gauge.WeekHdr.Font;
   		gh.size = Gauge.WeekHdr.FontSize;
   		gr.font = Gauge.WeekRng.Font;
   		gr.size = Gauge.WeekRng.FontSize;
   		gp.font = Gauge.WeekPip.Font;
   		gp.size = Gauge.WeekPip.FontSize;
   		gm.font = Gauge.WeekMsg.Font;
   		gm.size = Gauge.WeekMsg.FontSize;
   		
   		r.x	= Gauge.WeekRng.XOffset;
   		r.y	= Gauge.WeekRng.YOffset;
   		p.x	= Gauge.WeekPip.XOffset;
   		p.y	= Gauge.WeekPip.YOffset;
   		m.x	= Gauge.WeekMsg.XOffset;
   		m.y	= Gauge.WeekMsg.YOffset;
   	
   	} else {
   	
			g.corner= Gauge.Day.Corner;
   		gh.font = Gauge.DayHdr.Font;
   		gh.size = Gauge.DayHdr.FontSize;
   		gr.font = Gauge.DayRng.Font;
   		gr.size = Gauge.DayRng.FontSize;
   		gp.font = Gauge.DayPip.Font;
   		gp.size = Gauge.DayPip.FontSize;
   		gm.font = Gauge.DayMsg.Font;
   		gm.size = Gauge.DayMsg.FontSize;
   		
   		r.x	= Gauge.DayRng.XOffset;
   		r.y	= Gauge.DayRng.YOffset;
   		p.x	= Gauge.DayPip.XOffset;
   		p.y	= Gauge.DayPip.YOffset;
   		m.x	= Gauge.DayMsg.XOffset;
   		m.y	= Gauge.DayMsg.YOffset;   		

   	}
   	if (g.corner==1 || g.corner==3) { xadj=-1; tAlert=String.LeftPad(tAlert,25," "); } else xadj=1;
   	if (g.corner==3)  yadj=-1; else yadj=1;

   
   	Draw_Label(tag, boxname, BoxType, 													g.corner,signal.x.offset,					signal.y.offset,					gh.font,	gh.size,	EntryColor,		false,0);
   	Draw_Label(tag, boxname+"_range"," [" + boxtime + "]", 						g.corner,signal.x.offset+(r.x*xadj),	signal.y.offset+(r.y*yadj),	gr.font,	gr.size,	EntryColor,		false,0);
   	Draw_Label(tag, boxname+"_pips","(" + DoubleToStr(BoxSize,1)+" pips)", 	g.corner,signal.x.offset+(p.x*xadj),	signal.y.offset+(p.y*yadj),	gp.font,	gp.size,	White,			false,0);
   	Draw_Label(tag, boxsig, tAlert,						g.corner,signal.x.offset+(m.x*xadj),	signal.y.offset+(m.y*yadj),	gm.font,	gm.size,	tAlertColor,	false,0);
   
   }

   return(0);
   
}


//____________________________________________________________________________________________________________________________________________________________


int FindStartBar(int DOW, string starttime){

	int i=0;
	datetime baropen;
	
   while (i<1000) {
   
   		baropen = iTime(NULL,0,i);
        
         if (TimeToStr(baropen,TIME_MINUTES)==starttime) {
         
         	 if (DOW<0 || TimeDayOfWeek(baropen)==DOW) break; else i++;
         	 
         } else i++;
         
   }

   return(i);
   
}

//____________________________________________________________________________________________________________________________________________________________

int FindEndBar(int Start, int DOW, string endtime){

	int i=Start;
	datetime baropen;
	
   while (i>=0) {
   
   		baropen = iTime(NULL,0,i);
         
         if (TimeToStr(baropen,TIME_MINUTES)==endtime) {
         
         	 if (DOW<0 || TimeDayOfWeek(baropen)==DOW) break; else i--;
         	 
         } else i--;
         
   }
   
	if (i<0) i=0;
   return(i);
   
}